var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    selectImages();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup",function(evt){
        evt.preventDefault();
        evt.stopPropagation();
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
        mouseButtonPressed=noMouseButtonPressed;
    });

    $("#visualisation").on("mousedown",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        mouseButtonPressed=evt.button;
        handleMouseDown();
    });
}

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    BackStepLeft=border;//(width-38)/2;
    BackStepTop=BottomPanelTop+20;
    initialiseMatrices();
    matrixY=TopPanelHeight+80;
    matrixLineHeight=3*fontSize;
    matrixTop=matrixY-matrixLineHeight/2;
    
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    // Φόντα οθόνης
    drawPanels();
    drawLogoImage();
    showUserPrompts();
    drawSelectedUsage();
    drawSelectedExtensions();
    drawSelectedIcons();
}

function drawPanels(){
    //var lowRectTop=picTop+Intro.height+1;
    cntx.clearRect(0,0,width,TopPanelHeight);
    cntx.clearRect(0,BottomPanelTop,width,BottomPanelHeight);
    cntx.strokeStyle="black";
    cntx.fillStyle="rgb(255,255,255)";
    cntx.beginPath();
    cntx.fillRect(0,TopPanelHeight,width,height-TopPanelHeight-BottomPanelHeight);
    cntx.fill();
    cntx.beginPath();
    // πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    // άνω πλαίσιο
    cntx.rect(0,0,width,TopPanelHeight);
    // κάτω πλαίσιο
    cntx.rect(0,BottomPanelTop,width,height-BottomPanelTop);
    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if(stopFlag) drawButtonBack();
}

function drawLogoImage(){
    var picTop=TopPanelHeight;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonBack(){
    // Διαχείριση κουμπιού [Επόμενο Βήμα]
    if(buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if(mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else{
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    selectedItem=-1;
    for(var i=0;i<noOfSelections;i++){
        if(mx>=extensionX[i] && mx<extensionX[i]+cntx.measureText(extension[selectedData[i]]).width && my>=extensionY[i]-fontSize && my<extensionY[i]){
            selectedItem=i;
            selectedHeight=fontSize;
            dXItem=mx-extensionX[i];
            dYItem=my-extensionY[i];
            matrixLine=parseInt((extensionY[i]-matrixY)/matrixLineHeight);
            if(matrixLine>-1 && matrixLine<noOfSelections && extensionPlaced[matrixLine]){
                extensionPlaced[matrixLine]=false;
            }
        }
        else if(mx>iconX[i] && mx<iconX[i]+imgPic[i].width && my>iconY[i] && my<iconY[i]+imgPic[i].height){
            selectedItem=100+i;
            selectedHeight=imgPic[i].height;
            dXItem=mx-iconX[i];
            dYItem=my-iconY[i];
            matrixLine=parseInt((iconY[i]-matrixY+4*matrixLineHeight/10)/matrixLineHeight);
            if(matrixLine>-1 && matrixLine<noOfSelections && iconPlaced[matrixLine]){
                iconPlaced[matrixLine]=false;
            }
        }
    }
    drawBasicScreen();
}

function handleMouseMove(){
    var itemHover=false;
	canvas.style.cursor="default";
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(selectedItem>-1 && mouseButtonPressed==leftMouseButtonPressed){
        if(mx>=matrixX && my>=matrixY && my<matrixY+noOfSelections*matrixLineHeight) {
            canvas.style.cursor="all-scroll";
        }
        else{
            canvas.style.cursor="pointer";
        }
        if(selectedItem>=100){
            iconX[selectedItem-100]=mx-dXItem;
            iconY[selectedItem-100]=my-dYItem;
            if(iconY[selectedItem-100]>BottomPanelTop-40) {
                iconY[selectedItem-100]=BottomPanelTop-40;
                selectedItem=-1;
            }
            else if(iconY[selectedItem-100]<TopPanelHeight+20) {
                iconY[selectedItem-100]=TopPanelHeight+20;
                selectedItem=-1;
            }
        }
        else{
            extensionX[selectedItem]=mx-dXItem;
            extensionY[selectedItem]=my-dYItem;
            if(extensionY[selectedItem]>BottomPanelTop-20){
                extensionY[selectedItem]=BottomPanelTop-20;
                selectedItem=-1;
            }
            else if(extensionY[selectedItem]<TopPanelHeight+20){
                extensionY[selectedItem]=TopPanelHeight+20;
                selectedItem=-1;
            }
        }           
    }
    else{
        //Ανίχνευση ποντικιού πάνω από εικονίδιο
        for(var i=0;i<noOfSelections;i++){
            if(mx>=iconX[i] && mx<iconX[i]+imgPic[i].width && my>=iconY[i] && my<iconY[i]+imgPic[i].height){
                itemHover=true;
            }
        }
        //Ανίχνευση ποντικιού πάνω από Επέκταση
        for(var i=0;i<noOfSelections;i++){             
            if(mx>=extensionX[i] && mx<extensionX[i]+cntx.measureText(extension[selectedData[i]]).width && my>=extensionY[i]-fontSize && my<extensionY[i]){
                itemHover=true;
            }
        }
        if(itemHover){
            canvas.style.cursor="pointer";
        }
        else{
            canvas.style.cursor="default";
        }
    }
    drawBasicScreen();
}

function handleMouseUp(){
    var currentMatrixLine,curItemX,curItemY;
	draggingShape=false;
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    else if(stopFlag && mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight){
        selectImages();
    }
    else{
        if(selectedItem>-1){
            curItemX=mx-dXItem;
            curItemY=my-dYItem;
            if(mx>matrixX && curItemY>matrixTop && curItemY<matrixTop+noOfSelections*matrixLineHeight){
                currentMatrixLine=parseInt((my-matrixTop)/matrixLineHeight);
                if(selectedItem>=100) {
                    if(iconPlaced[currentMatrixLine]){ //Η γραμμή έχει ήδη περιεχόμενο
                        currentMatrixLine=0;
                        while(iconPlaced[currentMatrixLine]) currentMatrixLine++;
                    }
                    iconX[selectedItem-100]=matrixX+30;
                    iconY[selectedItem-100]=currentMatrixLine*matrixLineHeight-parseInt(4*matrixLineHeight/10)+matrixY;
                    iconPlaced[currentMatrixLine]=true;
                }
                else{
                    if(extensionPlaced[currentMatrixLine]){ //Η γραμμή έχει ήδη περιεχόμενο
                        currentMatrixLine=0;
                        while(extensionPlaced[currentMatrixLine]) currentMatrixLine++;
                    }
                    extensionX[selectedItem]=matrixX+140;
                    extensionY[selectedItem]=currentMatrixLine*matrixLineHeight+matrixY;
                    extensionPlaced[currentMatrixLine]=true;
                }
                canvas.style.cursor="default";
            }
            else{
                if(selectedItem>=100){
                    iconY[selectedItem-100]=matrixTop+noOfSelections*matrixLineHeight+2*selectedHeight;
                }
                else{
                    extensionY[selectedItem]=matrixTop+noOfSelections*matrixLineHeight+2*selectedHeight;
                }
            }
        }
        selectedItem=-1;
        checkFinish();        
    }
    drawBasicScreen();
}

function showUserPrompts(){
    var vTxtOffset=18;
    var hTxtOffset=2*border+imgBackStepSelected.width;
    var promptYCoord=BottomPanelTop+20;
    if(stopFlag){
        if(correctFlag){
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Μπράβο! Βρήκες όλους τους συνδυασμούς");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Πάτησε το κουμπί της επιστροφής για να ξαναδοκιμάσεις τις γνώσες σου...");
        }
        else if(solutionRevealed){
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Αυτοί είναι οι σωστοί συνδυασμοί.");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Πάτησε το κουμπί της επιστροφής για να ξαναδοκιμάσεις τις γνώσες σου...");
        }
        else{
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Οι συνδυασμοί δεν είναι σωστοί. Μπορείς να τους τροποποιήσεις");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"ή να δοκιμάσεις με νέα στοιχεία, πατώντας το κουμπί της επιστροφής...");
        }
    }
    else{
        cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Σύρε με το ποντίκι σου τα εικονίδια και τις επεκτάσεις που βρίσκονται");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"κάτω από τον πίνακα για να δημιουργήσεις τις σωστές τριάδες.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,promptFontSize,"Arial",hTxtOffset,promptYCoord,"Μπορείς να αποκαλύψεις τη λύση, πατώντας το κουμπί [Επίλυση].");
    }
}


function actionPerformed(btnSlctr){
    if(btnSlctr=="btnSolve"){
        solve();
    }
    drawBasicScreen();
}

function selectImages(){
    var i,j=0,k,m;          
    var found;          
    //reset selections
    for(i=0;i<noOfCategories;i++){
        categorySelected[i]=false;
    }
    for(i=0;i<noOfImages;i++){
        selected[i]=false;              
    }
    for(i=0;i<noOfSelections;i++){
        extensionPlaced[i]=false;
        extensionSlot[i]=false;
        iconPlaced[i]=false;
        iconSlot[i]=false;
    }
    //perform new selection
    for(i=0;i<noOfSelections;i++){
        found=false;
        while(!found){
            j=parseInt(Math.random()*noOfImages);
            found=!selected[j] && !categorySelected[itemCategory[j]];
        }
        selected[j]=true;
        categorySelected[itemCategory[j]]=true;
        selectedData[i]=j;
        imgPic[i]=document.getElementById(imageName[selectedData[i]]);
        do{
            k=parseInt(Math.random()*noOfSelections);
        }while(extensionSlot[k]);
        extensionSlot[k]=true;
        extensionX[i]=10+4*k*fontSize;
        extensionY[i]=matrixY+noOfSelections*matrixLineHeight;
        
        do{
            m=parseInt(Math.random()*noOfSelections);
        }while(iconSlot[m]);
        iconSlot[m]=true;
        iconX[i]=10+m*80;
        iconY[i]=extensionY[i]+parseInt(matrixLineHeight/2);
    }
    stopFlag=false;
}

function drawSelectedUsage(){
    var otherColumnsWidth=100;
    var matrixleft=10;
    var i;
    matrixX=0;
    for(i=0;i<noOfSelections;i++){
        cnvsWrite(LetterColor,fontSize,"Arial",matrixleft,matrixY+i*matrixLineHeight,usage[selectedData[i]]);
        if(matrixleft+cntx.measureText(usage[selectedData[i]]).width>matrixX) matrixX=matrixleft+cntx.measureText(usage[selectedData[i]]).width;
    }
    matrixX+=10;
    for(i=0;i<noOfSelections;i++){
        cntx.beginPath();
        cntx.rect(matrixleft-2,matrixY+(2*i-1)*matrixLineHeight/2,matrixleft-2+matrixX+2*otherColumnsWidth,matrixLineHeight);
        cntx.stroke();
    }
    cntx.beginPath();
    cntx.moveTo(matrixX,matrixY-matrixLineHeight/2);
    cntx.lineTo(matrixX,matrixY+(2*noOfSelections-1)*matrixLineHeight/2);
    cntx.moveTo(matrixX+otherColumnsWidth,matrixY-matrixLineHeight/2);
    cntx.lineTo(matrixX+otherColumnsWidth,matrixY+(2*noOfSelections-1)*matrixLineHeight/2);
    cntx.stroke();
}

function drawSelectedExtensions(){
    var i;
    for(i=0;i<noOfSelections;i++){
        cnvsWrite(LetterColor,fontSize,"Arial",extensionX[i],extensionY[i],extension[selectedData[i]]);
    }
}

function drawSelectedIcons(){
    var i;          
    for(i=0;i<noOfSelections;i++){
        cntx.drawImage(imgPic[i],iconX[i],iconY[i]);
    }
}

function initialiseMatrices(){
    imageName[0]="avi_b";
    imageName[1]="avi";
    imageName[2]="bin";
    imageName[3]="bmp";
    imageName[4]="com";
    imageName[5]="dll";
    imageName[6]="doc";
    imageName[7]="drv";
    imageName[8]="exe";
    imageName[9]="gif";
    imageName[10]="hlp";
    imageName[11]="html";
    imageName[12]="ie";
    imageName[13]="inf";
    imageName[14]="jpg";
    imageName[15]="mp3";
    imageName[16]="mp3_b";
    imageName[17]="mpg";
    imageName[18]="odt_b";
    imageName[19]="odt";
    imageName[20]="pdf";
    imageName[21]="png";
    imageName[22]="rar";
    imageName[23]="sxw";
    imageName[24]="tiff_b";
    imageName[25]="tiff";
    imageName[26]="txt";
    imageName[27]="wav_b";
    imageName[28]="wav";
    imageName[29]="xls_b";
    imageName[30]="xls";
    imageName[31]="zip";    
    extension[0]="avi";
    extension[1]="avi";
    extension[2]="bin";
    extension[3]="bmp";
    extension[4]="com";
    extension[5]="dll";
    extension[6]="doc";
    extension[7]="drv";
    extension[8]="exe";
    extension[9]="gif";
    extension[10]="hlp";
    extension[11]="html";
    extension[12]="ie";
    extension[13]="inf";
    extension[14]="jpg";
    extension[15]="mp3";
    extension[16]="mp3";
    extension[17]="mpg";
    extension[18]="odt";
    extension[19]="odt";
    extension[20]="pdf";
    extension[21]="png";
    extension[22]="rar";
    extension[23]="sxw";
    extension[24]="tiff";
    extension[25]="tiff";
    extension[26]="txt";
    extension[27]="wav";
    extension[28]="wav";
    extension[29]="xls";
    extension[30]="xls";
    extension[31]="zip";
    
    usage[0]="Βίντεο";
    usage[1]="Βίντεο";
    usage[2]="Αρχεία Λειτουργικού Συστήματος";
    usage[3]="Εικόνα";
    usage[4]="Πρόγραμμα";
    usage[5]="Αρχεία Λειτουργικού Συστήματος";
    usage[6]="Κείμενο σε Επεξεργαστή κειμένου";
    usage[7]="Αρχεία Λειτουργικού Συστήματος";
    usage[8]="Πρόγραμμα";
    usage[9]="Εικόνα";
    usage[10]="Αρχείο Βοήθειας";
    usage[11]="Υπερκείμενο";
    usage[12]="Υπερκείμενο";
    usage[13]="Αρχεία Λειτουργικού Συστήματος";
    usage[14]="Εικόνα";
    usage[15]="Ήχος";
    usage[16]="Ήχος";
    usage[17]="Βίντεο";
    usage[18]="Κείμενο σε Επεξεργαστή κειμένου";
    usage[19]="Κείμενο σε Επεξεργαστή κειμένου";
    usage[20]="Κείμενο Προστατευμένο από αλλαγές";
    usage[21]="Εικόνα";
    usage[22]="Συμπιεσμένο αρχείο";
    usage[23]="Κείμενο σε Επεξεργαστή κειμένου";
    usage[24]="Εικόνα";
    usage[25]="Εικόνα";
    usage[26]="Απλό κείμενο";
    usage[27]="Ήχος";
    usage[28]="Ήχος";
    usage[29]="Υπολογιστικό Φύλλο";
    usage[30]="Υπολογιστικό Φύλλο";
    usage[31]="Συμπιεσμένο αρχείο";
    
    itemCategory[0]=3;
    itemCategory[1]=3;
    itemCategory[2]=1;
    itemCategory[3]=4;
    itemCategory[4]=8;
    itemCategory[5]=1;
    itemCategory[6]=7;
    itemCategory[7]=1;
    itemCategory[8]=8;
    itemCategory[9]=4;
    itemCategory[10]=2;
    itemCategory[11]=10;
    itemCategory[12]=10;
    itemCategory[13]=1;
    itemCategory[14]=4;
    itemCategory[15]=5;
    itemCategory[16]=5;
    itemCategory[17]=3;
    itemCategory[18]=7;
    itemCategory[19]=7;
    itemCategory[20]=6;
    itemCategory[21]=4;
    itemCategory[22]=9;
    itemCategory[23]=7;
    itemCategory[24]=4;
    itemCategory[25]=4;
    itemCategory[26]=0;
    itemCategory[27]=5;
    itemCategory[28]=5;
    itemCategory[29]=11;
    itemCategory[30]=11;
    itemCategory[31]=9;
}

function checkFinish(){
    var i,extYCoord,iconYCoord;
    stopFlag=true;
    correctFlag=true;
    solutionRevealed=false;
    for(i=0;i<noOfSelections;i++){
        stopFlag=stopFlag & iconPlaced[i] & extensionPlaced[i];
        extYCoord=parseInt((extensionY[i]-matrixY)/matrixLineHeight);
        iconYCoord=parseInt((iconY[i]+4*matrixLineHeight/10-matrixY)/matrixLineHeight);
        correctFlag=correctFlag & extYCoord==i & iconYCoord==i; 
    }
}

function solve(){
    stopFlag=true;
    correctFlag=false;
    solutionRevealed=true;
    for(var i=0;i<noOfSelections;i++){
        iconX[i]=matrixX+30;
        iconY[i]=i*matrixLineHeight-parseInt(4*matrixLineHeight/10)+matrixY;
        extensionX[i]=matrixX+140;
        extensionY[i]=i*matrixLineHeight+matrixY;
    }
}